use 5.010001;
use strict;
use warnings;

package AtteanX::Query::Cache;

our $AUTHORITY = 'cpan:KJETILK';
our $VERSION   = '0.001_04';
use Moo;

extends 'AtteanX::Endpoint';

after 'log_query' => sub {
	my $self	= shift;
	my $req		= shift;
	my $message	= shift;
	$self->model->publisher->publish('analyze.fullquery', $message);
};

1;

__END__

=pod

=encoding utf-8

=head1 NAME

AtteanX::Query::Cache - Experimental prefetching SPARQL query cacher

=head1 SYNOPSIS

=head1 DESCRIPTION

=head1 BUGS

Please report any bugs to
L<http://rt.cpan.org/Dist/Display.html?Queue=AtteanX-Query-Cache>.

=head1 SEE ALSO

=head1 AUTHOR

Kjetil Kjernsmo E<lt>kjetilk@cpan.orgE<gt>.

=head1 COPYRIGHT AND LICENCE

This software is copyright (c) 2015, 2016 by Kjetil Kjernsmo.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.


=head1 DISCLAIMER OF WARRANTIES

THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

